package com.nju.svcdisambiguation.dataMapper.ieee;

import com.nju.svcdisambiguation.po.FieldSummaryPO;
import com.nju.svcdisambiguation.po.PaperActivationPO;
import com.nju.svcdisambiguation.vo.detail.author.AuthorDetailVO;
import com.nju.svcdisambiguation.vo.detail.author.AuthorPublicationSummaryVO;
import com.nju.svcdisambiguation.vo.detail.author.InstitutionAuthorDetailVO;
import com.nju.svcdisambiguation.vo.detail.author.KeywordsAuthorDetailVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.ArrayList;

@Mapper
@Repository
public interface IEEEAuthorDetailMapper {

    ArrayList<AuthorPublicationSummaryVO> selectAuthorPublicationSummaryByAuthorId(@Param("authorId") int authorId);

    ArrayList<FieldSummaryPO> selectFieldSummaryPOByAuthorId(@Param("authorId") int authorId);

    AuthorDetailVO selectAuthorDetailById(@Param("authorId") int authorId);

    ArrayList<InstitutionAuthorDetailVO> selectInstitutionByAuthorId(@Param("authorId") int authorId);

    ArrayList<PaperActivationPO> selectPaperActivationPOByAuthorId(@Param("authorId") int authorId);

    ArrayList<String> selectSameAuthorsByAuthorId(@Param("authorId") int authorId);

    Integer selectDocCountByAuthorId(@Param("authorId") int authorId);

    ArrayList<KeywordsAuthorDetailVO> selectKeywordsAuthorDetailByAuthorId(@Param("authorId") int authorId);

    ArrayList<PaperActivationPO> selectPAVOByFieldNameAndAuthorId(@Param("fieldName") String fieldName, @Param("authorId") int authorId);
}
